/**
 * Copyright (c) 2003 held jointly by the individual authors.            
 *                                                                          
 * This library is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU Lesser General Public License as published      
 * by the Free Software Foundation; either version 2.1 of the License, or 
 * (at your option) any later version.                                            
 *                                                                            
 * This library is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; with out even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU Lesser General Public License for more details.                                                  
 *                                                                           
 * You should have received a copy of the GNU Lesser General Public License   
 * along with this library;  if not, write to the Free Software Foundation,   
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA.              
 *                                                                            
 * > http://www.gnu.org/copyleft/lesser.html                                  
 * > http://www.opensource.org/licenses/lgpl-license.php
 */
package net.mlw.vlh.adapter.jdbc.dynclass;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import net.mlw.vlh.ValueListInfo;
import net.mlw.vlh.adapter.jdbc.AbstractDynaJdbcAdapter;
import net.mlw.vlh.adapter.jdbc.util.ResultSetMapGenerator;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import dynclass.BeanCreator;

/**
 * @see net.mlw.vlh.adapter.jdbc.AbstractDynaJdbcAdapter
 * @see net.mlw.vlh.adapter.jdbc.AbstractJdbcAdapter
 *
 * @author Matthew L. Wilson, Andrej Zachar
 * @version $Revision: 1.8 $ $Date: 2005/08/19 16:06:29 $
 */
public class DefaultDynclassAdapter extends AbstractDynaJdbcAdapter
{

   private static final Log LOGGER = LogFactory.getLog(DefaultDynclassAdapter.class);

   public List processResultSet(String name, ResultSet result, int numberPerPage, ValueListInfo info) throws SQLException
   {
      List list = new ArrayList();

      ResultSetMapGenerator bg = new ResultSetMapGenerator(result, isUseName(), isLowerCase());
      for (int i = 0; result.next() && i < numberPerPage; i++)
      {
         try
         {
            Map properties = bg.generateMap();
            list.add(BeanCreator.createBeanFromMap(properties));
         }
         catch (Exception e)
         {
            LOGGER.error(e);
         }
      }
      return list;
   }
}