/**
 * Copyright (c) 2003 held jointly by the individual authors.            
 *                                                                          
 * This library is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU Lesser General Public License as published      
 * by the Free Software Foundation; either version 2.1 of the License, or 
 * (at your option) any later version.                                            
 *                                                                            
 * This library is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; with out even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU Lesser General Public License for more details.                                                  
 *                                                                           
 * You should have received a copy of the GNU Lesser General Public License   
 * along with this library;  if not, write to the Free Software Foundation,   
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA.              
 *                                                                            
 * > http://www.gnu.org/copyleft/lesser.html                                  
 * > http://www.opensource.org/licenses/lgpl-license.php
 */
package net.mlw.vlh.swing.support.filter;

import javax.swing.AbstractButton;

import net.mlw.vlh.Errors;

/**
 * @author Matthew L. Wilson
 * @version $Revision: 1.3 $ $Date: 2006/05/04 15:30:43 $
 */
public class ButtonFilterRetriever extends AbstractFilterRetriever
{
   private boolean uncheck = false;

   private AbstractButton button;

   private boolean defaultValue = true;

   public ButtonFilterRetriever(String key, AbstractButton button)
   {
      this(key, button, false);
   }

   public ButtonFilterRetriever(String key, AbstractButton button, boolean uncheck)
   {
      this(key, button, uncheck, false);
   }

   public ButtonFilterRetriever(String key, AbstractButton button, boolean uncheck, boolean defaultValue)
   {
      super(key);
      this.button = button;
      this.uncheck = uncheck;
      this.defaultValue = defaultValue;
   }

   public Object getFilterValue(Errors errors)
   {
      if (button.isSelected())
      {
         if (uncheck)
         {
            button.setSelected(false);
         }
         return "true";
      }
      else
      {
         return "";
      }
   }

   public Object reset()
   {
      button.setSelected(defaultValue);
      return (button.isSelected()) ? "true" : "";
   }
}